// 计算函数
function calculator(ev) {
  // 显示结果区
  const result = document.querySelector('.result')

  // 当前按钮(事件代理)
  if (ev.target.tagName !== 'BUTTON') return false

  // 当前按钮
  const curBtn = ev.target

  // 按钮内容
  let content = curBtn.textContent

  //   eval('字符串表达式'): 将一个字符串表达式进行计算并返回结果

  // 将内容显示到结果区
  // 根据用户点击的按钮内容确定要执行的操作
  switch (content) {
    // AC 清零
    case 'AC':
      result.value = 0
      break

    // CE: 退格
    case 'CE':
      // 如果结果区有内容
      if (result.value.length == 1 || result.value == '错误') {
        result.value = 0
      } else {
        // 删除最后一个字符
        // slice(startIndex,endIndex),结果中不包含结束索引的值
        result.value = result.value.slice(0, -1)
      }
      break

    // F1
    case 'F1':
      break
    // F2
    case 'F2':
      break

    // = : 计算结果
    case '=':
      // 缓存结果
      let tmpResult = 0

      try {
        //   如果是乘法,将 "X" 换成 "*"
        result.value = result.value.replace('X', '*')
        // 计算字符串表达式
        tmpResult = eval(result.value)

        // 如果结果是小数,仅保留5位就可以了
        if (tmpResult.toString().includes('.')) {
          tmpResult = tmpResult.toFixed(5)
          // 如果小数部分出现了多余的0,应该去掉(对结果精度没影响)
          tmpResult = parseFloat(tmpResult)
        }

        // 显示出结果
        result.value = tmpResult
      } catch {
        result.value = '错误'
      }

      break

    default:
      // 如果当前结果区显示有前导0,先清空, 防止出现前导0
      if (result.value == 0 || result.value == '错误') result.value = ''

      result.value += content
  }
}

/**
 * 知识点总结
 * 1. 事件代理
 * 2. eval()
 * 3. try-catch
 * 4. toFixed()
 */

/**
 * 作业
 * 1. 处理除零错误
 * 2. 处理操作符位于表达式首位的错误
 */
